unit selctMapTest;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, TeeProcs, TeeTree, TeeDBTre, StdCtrls, ComCtrls, Provider,
  DB, DBClient, TeeGDIPlus;

type
  TForm12 = class(TForm)
    DBTree1: TDBTree;
    RichEdit1: TRichEdit;
    RichEdit2: TRichEdit;
    procedure FormCreate(Sender: TObject);
    procedure DBTree1ClickShape(Sender: TTreeNodeShape; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure DBTree1ExpandingCollapsing(Sender: TTreeNodeShape;
      var Expand: Boolean);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form12: TForm12;

implementation

{$R *.dfm}

procedure TForm12.FormCreate(Sender: TObject);
var
  rootShape,
  tmpShape      : TTreeNodeShape;
  i             : Integer;

  procedure AddShape(AText: string; ATag: Integer; AParent: Integer);
  var ParentShape: TTreeNodeShape;
  begin
    ParentShape:=DBTree1.FindNodeCode(AParent);
    ParentShape.AddChild(AText).Tag:=ATag;
  end;

  procedure AddChilds(AParent: TTreeNodeShape; ACount: Integer);
  var i: Integer;
  begin
    for i:=0 to ACount-1 do
      AddShape(Trim(AParent.Text.Text)+'.'+IntToStr(i+1), DBTree1.Shapes.Count+1, AParent.Tag);
  end;

begin
  DBTree1.Layout.Add;

  rootShape:=DBTree1.Add('Node 1');
  rootShape.Tag:=1;

  i:=0;
  while (DBTree1.Shape[i].Level<3) do
  begin
    AddChilds(DBTree1.Shape[i], 3);
    Inc(i);
  end;

  for i:=0 to DBTree1.Shapes.Count-1 do
    with DBTree1.Shapes[i] do
      Expanded:=(Level=1) {or (Level=0)};

  RichEdit1.Clear;
  RichEdit2.Clear;
  RichEdit2.Lines.Add('LOG:'+sLineBreak+'- Expanded shapes:');
  for i:=0 to DBTree1.Shapes.Count-1 do
    if DBTree1.Shape[i].Expanded then
      RichEdit2.Lines.Add(Trim(DBTree1.Shape[i].Text.Text));
end;

//*****************************************************************************


procedure TForm12.DBTree1ClickShape(Sender: TTreeNodeShape;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  RichEdit1.Clear;
  RichEdit1.Lines.Add('Tag:'+InttoStr(Sender.tag));
  RichEdit1.Lines.Add('Top:'+InttoStr(Sender.top));
  RichEdit1.Lines.Add('Left:'+InttoStr(Sender.left));
  RichEdit1.Lines.Add('Height:'+InttoStr(Sender.height));
  RichEdit1.Lines.Add('Width:'+InttoStr(Sender.width));
  RichEdit1.Lines.Add('Text:' + Sender.Text[0]);

  RichEdit2.Lines.Add('- Clicked shape: ' + Sender.Text[0]);
end;

procedure TForm12.DBTree1ExpandingCollapsing(Sender: TTreeNodeShape;
  var Expand: Boolean);
begin
  RichEdit2.Lines.Add('- Expanding/collapsing shape: ' + Sender.Text[0]);
end;

end.
